Unit XMS;                              { By Vulture/OT 1998 }

{
  First check if an XMS driver is installed. If so, get the XMS controller
  function, which will serve as some sort of interrupt function for us.
  Then get the driver version, because some function only work with specific
  versions. From then on, we can use all XMS API functions which are accessed
  using the XMS driver's Control Function, like stated above.
}

INTERFACE

Type XMS_MemoryStructure =
     Record
       Length       : Longint;         { 32-bit even (!) number of bytes to transfer }
       SourceHandle : Word;            { Handle of source block }
       SourceOffset : Pointer;         { 32-bit offset into source }
       DestHandle   : Word;            { Handle of destination block }
       DestOffset   : Longint;         { 32-bit offset into destination block }
     End;

     XMS_MemoryStructure2 =
     Record
       Length       : Longint;         { 32-bit even (!) number of bytes to transfer }
       SourceHandle : Word;            { Handle of source block }
       SourceOffset : Longint;         { 32-bit offset into source }
       DestHandle   : Word;            { Handle of destination block }
       DestOffset   : Pointer;         { 32-bit offset into destination block }
     End;

Var XMS_Control: Pointer;
Var Block: ^XMS_MemoryStructure;

Function XMS_Installed: Byte;
Procedure XMS_Controller;
Function XMS_DriverVersion: Word;
Function XMS_SearchFreeMemory: Word;
Function XMS_Allocate(Size: Word): Word;
Procedure XMS_FreeMemory(Handle: Word);
Procedure XMS_MoveMemory(Var Block: XMS_MemoryStructure);
Procedure XMS_MoveMemory2(Var Block: XMS_MemoryStructure2);
Procedure TestMove1(Length: Longint; SourceHandle: Word; SourceOffset: Pointer;
                    DestHandle: Word; DestOffset: Longint);

IMPLEMENTATION

Function XMS_Installed: Byte; Assembler;
Asm
   mov     ax,4300h
   int     2Fh
   cmp     al,80h
   je      @XMSDriverPresent
   mov     al,00h
@XMSDriverPresent:
End;

Procedure XMS_Controller; Assembler;
Asm
   mov     ax,4310h
   int     2Fh
   mov     word ptr [XMS_Control],bx
   mov     word ptr [XMS_Control+2],es
End;

Function XMS_DriverVersion: Word; Assembler;
Asm
   mov     ah,00h
   call    [XMS_Control]
End;

Function XMS_SearchFreeMemory: Word; Assembler;
Asm
   mov     ah,08h
   call    [XMS_Control]
   mov     ax,dx
End;

Function XMS_Allocate(Size: Word): Word; Assembler;
Asm
   mov     ah,09h
   mov     dx,Size
   call    [XMS_Control]
   cmp     ax,0001h
   jne     @Mem_Allocated
   mov     ax,dx                       { Return handle in ax }
@Mem_Allocated:
End;

Procedure XMS_FreeMemory(Handle: Word); Assembler;
Asm
   mov     ah,0Ah
   mov     dx,Handle
   call    [XMS_Control]
End;

Procedure XMS_MoveMemory(Var Block: XMS_MemoryStructure); Assembler;
Asm
   push    ds
   mov     ah,0Bh
   lds     si,Block
   call    [XMS_Control]
   pop     ds
End;

Procedure TestMove1(Length: Longint; SourceHandle: Word; SourceOffset: Pointer;
                    DestHandle: Word; DestOffset: Longint);
Begin
  Block^.Length := Length;
  Block^.SourceHandle := SourceHandle;
  Block^.SourceOffset := SourceOffset;
  Block^.DestHandle := DestHandle;
  Block^.DestOffset := DestOffset;
  Asm
     push    ds
     mov     ah,0Bh
     lds     si,Block
     call    [XMS_Control]
     pop     ds
  End;
End;

Procedure XMS_MoveMemory2(Var Block: XMS_MemoryStructure2); Assembler;
Asm
   push    ds
   mov     ah,0Bh
   lds     si,Block
   call    [XMS_Control]
   pop     ds
End;

BEGIN
END.